"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactSwipeable = require("react-swipeable");

var _ = require("..");

var _style = _interopRequireDefault(require("./style"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class TocItem extends _react.PureComponent {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "setLocation", () => {
      this.props.setLocation(this.props.href);
    });
  }

  render() {
    const _this$props = this.props,
          label = _this$props.label,
          styles = _this$props.styles;
    return /*#__PURE__*/_react.default.createElement("button", {
      onClick: this.setLocation,
      style: styles
    }, label);
  }

}

TocItem.propTypes = {
  label: _propTypes.default.string,
  href: _propTypes.default.string,
  setLocation: _propTypes.default.func,
  styles: _propTypes.default.object
};

class ReactReader extends _react.PureComponent {
  constructor(props) {
    super(props);

    _defineProperty(this, "toggleToc", () => {
      this.setState({
        expanedToc: !this.state.expanedToc
      });
    });

    _defineProperty(this, "next", () => {
      const node = this.readerRef.current;
      node.nextPage();
    });

    _defineProperty(this, "prev", () => {
      const node = this.readerRef.current;
      node.prevPage();
    });

    _defineProperty(this, "onTocChange", toc => {
      const tocChanged = this.props.tocChanged;
      this.setState({
        toc: toc
      }, () => tocChanged && tocChanged(toc));
    });

    _defineProperty(this, "setLocation", loc => {
      const locationChanged = this.props.locationChanged;
      this.setState({
        expanedToc: false
      }, () => locationChanged && locationChanged(loc));
    });

    this.readerRef = /*#__PURE__*/_react.default.createRef();
    this.state = {
      expanedToc: false,
      toc: false
    };
  }

  renderToc() {
    const _this$state = this.state,
          toc = _this$state.toc,
          expanedToc = _this$state.expanedToc;
    const styles = this.props.styles;
    return /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("div", {
      style: styles.tocArea
    }, /*#__PURE__*/_react.default.createElement("div", {
      style: styles.toc
    }, toc.map((item, i) => /*#__PURE__*/_react.default.createElement(TocItem, _extends({}, item, {
      key: i,
      setLocation: this.setLocation,
      styles: styles.tocAreaButton
    }))))), expanedToc && /*#__PURE__*/_react.default.createElement("div", {
      style: styles.tocBackground,
      onClick: this.toggleToc
    }));
  }

  renderTocToggle() {
    const expanedToc = this.state.expanedToc;
    const styles = this.props.styles;
    return /*#__PURE__*/_react.default.createElement("button", {
      style: Object.assign({}, styles.tocButton, expanedToc ? styles.tocButtonExpaned : {}),
      onClick: this.toggleToc
    }, /*#__PURE__*/_react.default.createElement("span", {
      style: Object.assign({}, styles.tocButtonBar, styles.tocButtonBarTop)
    }), /*#__PURE__*/_react.default.createElement("span", {
      style: Object.assign({}, styles.tocButtonBar, styles.tocButtonBottom)
    }));
  }

  render() {
    const _this$props2 = this.props,
          title = _this$props2.title,
          showToc = _this$props2.showToc,
          loadingView = _this$props2.loadingView,
          styles = _this$props2.styles,
          locationChanged = _this$props2.locationChanged,
          swipeable = _this$props2.swipeable,
          props = _objectWithoutProperties(_this$props2, ["title", "showToc", "loadingView", "styles", "locationChanged", "swipeable"]);

    const _this$state2 = this.state,
          toc = _this$state2.toc,
          expanedToc = _this$state2.expanedToc;
    return /*#__PURE__*/_react.default.createElement("div", {
      style: styles.container
    }, /*#__PURE__*/_react.default.createElement("div", {
      style: Object.assign({}, styles.readerArea, expanedToc ? styles.containerExpaned : {})
    }, showToc && this.renderTocToggle(), /*#__PURE__*/_react.default.createElement("div", {
      style: styles.titleArea
    }, title), /*#__PURE__*/_react.default.createElement(_reactSwipeable.Swipeable, {
      onSwipedRight: this.prev,
      onSwipedLeft: this.next,
      trackMouse: true
    }, /*#__PURE__*/_react.default.createElement("div", {
      style: styles.reader
    }, /*#__PURE__*/_react.default.createElement(_.EpubView, _extends({
      ref: this.readerRef,
      loadingView: loadingView
    }, props, {
      tocChanged: this.onTocChange,
      locationChanged: locationChanged
    })), swipeable && /*#__PURE__*/_react.default.createElement("div", {
      style: styles.swipeWrapper
    }))), /*#__PURE__*/_react.default.createElement("button", {
      style: Object.assign({}, styles.arrow, styles.prev),
      onClick: this.prev
    }, "\u2039"), /*#__PURE__*/_react.default.createElement("button", {
      style: Object.assign({}, styles.arrow, styles.next),
      onClick: this.next
    }, "\u203A")), showToc && toc && this.renderToc());
  }

}

ReactReader.defaultProps = {
  loadingView: /*#__PURE__*/_react.default.createElement("div", {
    style: _style.default.loadingView
  }, "Loading\u2026"),
  locationChanged: null,
  tocChanged: null,
  showToc: true,
  styles: _style.default
};
ReactReader.propTypes = {
  title: _propTypes.default.string,
  loadingView: _propTypes.default.element,
  showToc: _propTypes.default.bool,
  locationChanged: _propTypes.default.func,
  tocChanged: _propTypes.default.func,
  styles: _propTypes.default.object,
  swipeable: _propTypes.default.bool
};
var _default = ReactReader;
exports.default = _default;